{#if rows.length}
<div class="emoji-category">
  <h3 class="category-name">{name}</h3>
  <div class="category-items">
    {#each rows as row, rowIndex}
    <div class="emoji-row">
      {#each row as emoji (emoji.n)}
      <div class="picker-emoji"
           on:mouseenter="fire('hover', ':' + diversify(emoji, color, shape) + ':')"
           on:mouseleave="fire('hover', undefined)"
           on:click="fire('insert', ':' + diversify(emoji, color, shape) + ':')">
        <img class="picker-emoji-icon"
             on:click|once="forceLoad(rowIndex)"
             use:lazyLoadChild="{emoji, color, shape, rowIndex}"
             src="../icons/1x1-tsp.png"
             alt={':' + diversify(emoji, color, shape) + ':'} />
      </div>
      {/each}
    </div>
    {/each}
  </div>
</div>
{/if}

<script>
  import EmojiUtils from "../js/EmojiUtils";
  import {ROW_HEIGHT, NAME_HEIGHT} from "../js/EmojiPickerConstants";

  function diversify(emoji, color, shape) {
    let name = emoji.n;
    if (emoji.s) name += "_" + shape;
    if (emoji.c) name += "_" + color;
    return name;
  }
  
  export default {
    helpers: {
      diversify
    },
    actions: {
      lazyLoadChild(node, {emoji, rowIndex, color, shape}) {
        if (!this._loadingRows) this._loadingRows = {};
        if (!this._loadingRows[rowIndex]) {
          this._loadingRows[rowIndex] = {[emoji.n]: load};
        } else {
          this._loadingRows[rowIndex][emoji.n] = load;
        }

        let loaded = false;

        function load() {
          node.src = EmojiUtils.urlFor(diversify(emoji, color, shape));
          loaded = true;
        }

        return {
          update(data) {
            if (data.rowIndex != rowIndex || data.emoji != emoji) {
              // console.log("Updating!");
              if (this._loadingRows[rowIndex]) {
                delete this._loadingRows[rowIndex][emoji.n];
              }
              if (this._loadingRows[data.rowIndex]) {
                this._loadingRows[data.rowIndex][data.emoji.n] = load;
              } else {
                this._loadingRows[data.rowIndex] = {[data.emoji.n]: load};
              }
              emoji = data.emoji;
              rowIndex = data.rowIndex;
            }
            if (data.color != color || data.shape != shape) {
              color = data.color;
              shape = data.shape;
              if (loaded) load();
            }
          },
          destroy() {
            //            if (this._loadingRows[rowIndex]) {
            //              delete this._loadingRows[rowIndex][emoji];
            //            }
          }
        };
      }
    },
    onupdate({changed, current}) {
      if (
        changed.scrollTop ||
        changed.clientHeight ||
        changed.offset ||
        changed.rows
      ) {
        this.onScroll(current.scrollTop, current.clientHeight, current.offset);
      }
    },
    methods: {
      forceLoad(rowIndex) {
        if (this._loadingRows[rowIndex]) {
          for (const emoji in this._loadingRows[rowIndex]) {
            this._loadingRows[rowIndex][emoji]();
          }
          delete this._loadingRows[rowIndex];
        }
      },
      onScroll(minPosition, clientHeight, offset) {
        // console.time("EmojiCategory.onScroll()");
        // 100 buffer on either side
        const maxPosition = minPosition + clientHeight + 200;
        for (const rowIndex in this._loadingRows) {
          const rowPosition = rowIndex * ROW_HEIGHT + NAME_HEIGHT + offset;
          if (rowPosition < maxPosition && rowPosition > minPosition) {
            // console.log("WE'VE LOADED", rowIndex);
            for (const emoji in this._loadingRows[rowIndex]) {
              this._loadingRows[rowIndex][emoji]();
            }
            // Simply no longer needed
            delete this._loadingRows[rowIndex];
          }
          // Unfortunately, we can still scroll backwards :c
          // else break;
        }
        // console.timeEnd("EmojiCategory.onScroll()");
      }
    },
    computed: {
      rows({items, rowWidth}) {
        const rows = [];
        for (let index in items) {
          if (index % rowWidth === 0) rows.push([items[index]]);
          else rows[rows.length - 1].push(items[index]);
        }
        return rows;
      }
    }
  };
</script>

<style>
  .picker-emoji-icon,
  .picker-emoji {
    display: inline-block;
    overflow: hidden;
  }
  .picker-emoji {
    border-radius: 2px;
    cursor: pointer;

    height: 32px;
    width: 32px;
  }
  .picker-emoji-icon {
    margin: 2px;
    height: 28px;
    width: 28px;
  }
  .picker-emoji:hover {
    background-color: #4b4f52;
  }
  .category-name {
    font-size: 0.85rem;
    margin: 0.5rem 0;
    color: #787878;
    text-transform: uppercase;
  }

  .emoji-row {
    /* bela says chromium needs this..? */
    width: 320px;
  }

  @media (max-width: 700px) {
    .emoji-row {
      width: calc(100vw - 16px);
    }
  }
</style>
